source/api/urls.py
from django.urls import path, include
from rest_framework import routers
from .views import CommentViewSet, LikeView, DislikeView

router = routers.DefaultRouter()
router.register(r'comments', CommentViewSet)

app_name = 'api'

urlpatterns = [
    path('', include(router.urls)),
    path('like/<int:pk>/', LikeView.as_view(), name='like_photo'),
    path('dislike/<int:pk>/', DislikeView.as_view(), name='dislike_photo')
]

source/main/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static


urlpatterns = [
    path('', include('webapp.urls')),
    path('api/', include('api.urls')),
    path('admin/', admin.site.urls),
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

source/webapp/urls.py
from django.urls import path
from .views import PhotoDetailView, PhotoListView
from django.contrib.auth.views import LoginView, LogoutView

app_name = 'webapp'

urlpatterns = [
    path('', PhotoListView.as_view(), name='photo_list'),
    path('photo/<int:pk>/', PhotoDetailView.as_view(), name='photo_detail'),
    path('login/', LoginView.as_view(), name='login'),
    path('logout/', LogoutView.as_view(), name='logout')
]

source/api/models.py
from django.db import models

# Create your models here.

source/webapp/models.py
from django.db import models


class Photo(models.Model):
    photo = models.ImageField(upload_to='images')
    label = models.CharField(max_length=20)
    author = models.ForeignKey('auth.User', on_delete=models.PROTECT, related_name='photos')
    likes_count = models.PositiveIntegerField(default=0)
    created_at = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return f'{self.label}'


class Comment(models.Model):
    text = models.TextField()
    photo = models.ForeignKey('Photo', on_delete=models.CASCADE, related_name='comments')
    author = models.ForeignKey('auth.User', on_delete=models.CASCADE, related_name='comments')
    created_at = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return f'{self.text[:20]}'


class Like(models.Model):
    photo = models.ForeignKey('Photo', on_delete=models.CASCADE, related_name='likes')
    author = models.ForeignKey('auth.User', on_delete=models.CASCADE, related_name='likes')

    def __str__(self):
        return f'{self.author.username} | {self.photo.label}'

    class Meta:
        unique_together = ('photo', 'author')

source/api/views.py
from rest_framework.response import Response
from rest_framework.views import APIView
from rest_framework.viewsets import ModelViewSet
from rest_framework.permissions import BasePermission
from .serializers import CommentSerializer
from webapp.models import Comment, Photo, Like


class IsAuthorPermission(BasePermission):
    def has_object_permission(self, request, view, obj):
        if request.method in ('DELETE', 'PUT', 'PATCH'):
            return obj.author == request.user or request.user.has_perm('webapp.delete_comment')
        return True


class CommentViewSet(ModelViewSet):
    serializer_class = CommentSerializer
    queryset = Comment.objects.all()

    def get_permissions(self):
        if self.request.method == 'DELETE':
            return [IsAuthorPermission(),]
        else:
            return super().get_permissions()


class LikeView(APIView):
    def post(self, request, *args, **kwargs):
        pk = kwargs.get('pk')
        try:
            photo = Photo.objects.get(pk=pk)
        except Photo.DoesNotExist:
            return Response({'error': 'Photo not found!'}, status=404)
        try:
            Like.objects.get(photo=photo, author=request.user)
            return Response({'error': 'You have already liked this photo!'}, status=400)
        except Like.DoesNotExist:
            Like.objects.create(photo=photo, author=request.user)
            photo.likes_count += 1
            photo.save()
            return Response({'id': photo.pk, 'likes_count': photo.likes_count})


class DislikeView(APIView):
    def post(self, request, *args, **kwargs):
        pk = kwargs.get('pk')
        try:
            photo = Photo.objects.get(pk=pk)
        except Photo.DoesNotExist:
            return Response({'error': 'Photo not found!'}, status=404)
        try:
            Like.objects.get(photo=photo, author=request.user).delete()
            photo.likes_count -= 1
            photo.save()
            return Response({'id': photo.pk, 'likes_count': photo.likes_count})
        except Like.DoesNotExist:
            return Response({'error': 'You have not liked this photo yet!'}, status=400)

source/webapp/views.py
from django.views.generic import ListView, DetailView
from .models import Photo, Like
from django.views.decorators.csrf import ensure_csrf_cookie
from django.utils.decorators import method_decorator


@method_decorator(ensure_csrf_cookie, name='dispatch')
class PhotoListView(ListView):
    model = Photo
    template_name = 'photo_list.html'
    context_object_name = 'photos'


@method_decorator(ensure_csrf_cookie, name='dispatch')
class PhotoDetailView(DetailView):
    model = Photo
    template_name = 'photo_detail.html'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        if self.request.user.is_authenticated:
            try:
                Like.objects.get(author=self.request.user, photo=self.object)
                context['liked'] = True
            except Like.DoesNotExist:
                context['liked'] = False
        return context

source/webapp/templates/base.html
{% load staticfiles %}
<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>{% block title %}MySite{% endblock %}</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <link rel="stylesheet" href="{% static "css/style.css" %}">
    {% block styles %}{% endblock %}
</head>
<body>
{% block menu %}{% endblock %}
<div class="container">
    {% block content %}{% endblock %}
</div>
<script src="https://code.jquery.com/jquery-3.4.1.min.js" integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo=" crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>
<script type="application/javascript" src="{% static "js/main.js" %}"></script>
{% block scripts %}{% endblock %}
</body>
</html>

source/webapp/templates/photo_detail.html
{% extends 'base.html' %}
{% load staticfiles %}

{% block title %}Photo{% endblock %}

{% block content %}
    <div class="card my-3">
        <img src="{{ photo.photo.url }}" alt="{{ photo.label }}" class="card-img-top">
        <div class="card-body">
            <h3 class="card-title">{{ photo.label }}</h3>
            <p class="card-subtitle text-muted">{{ photo.author }} | {{ photo.created_at|date:"Y-m-d H:i:s" }} |
                likes: <span id="likes-display-{{ photo.pk }}">{{ photo.likes_count }}</span></p>
            {% if request.user.is_authenticated %}
                <p class="mt-2 mb-0">
                    <a href="#" class="btn btn-success {% if liked %}d-none{% endif %} like-btn"
                       id="like-btn-{{ photo.pk }}" data-id="{{ photo.pk }}">Like</a>
                    <a href="#" class="btn btn-danger {% if not liked %}d-none{% endif %} dislike-btn"
                       id="dislike-btn-{{ photo.pk }}" data-id="{{ photo.pk }}">Dislike</a>
                </p>
            {% endif %}
        </div>
    </div>
    <div id="comment-list">
        {% for comment in photo.comments.all %}
            <div class="card my-3" id="comment-{{ comment.id }}">
                <div class="card-body">
                    {% if request.user == comment.author or perms.webapp.delete_comment %}
                        <button type="button" class="close" aria-label="Close" id="comment-delete-{{ comment.id }}"
                                data-id="{{ comment.id }}">&times;</button>
                    {% endif %}
                    <p class="card-text">{{ comment.text }}</p>
                    <p class="card-subtitle text-muted">{{ comment.author }}
                        | {{ comment.created_at|date:"Y-m-d H:i:s" }}</p>
                </div>
            </div>
        {% endfor %}
    </div>
    {% if request.user.is_authenticated %}
        <hr class="my-4">
        <div class="card my-3">
            <div class="card-body">
                <form class="form" id="comment-form">
                    <input type="hidden" name="author" id="author" value="{{ request.user.pk }}">
                    <input type="hidden" name="photo" id="photo" value="{{ photo.pk }}">
                    <div class="form-group">
                        <label for="text">Добавить комментарий: </label>
                        <textarea class="form-control" id="text" name="text"></textarea>
                    </div>
                    <div class="mt-3">
                        <button type="submit" class="btn btn-primary" id="comment-save">Сохранить</button>
                    </div>
                </form>
            </div>
        </div>
    {% endif %}
{% endblock %}

{% block scripts %}
    <script>
        const userName = "{{ request.user.username }}";
    </script>
    <script type="application/javascript" src="{% static "js/comments.js" %}"></script>
{% endblock %}

source/webapp/templates/photo_list.html
{% extends 'base.html' %}
{% block title %}Photo{% endblock %}
{% block content %}
    {% for photo in photos %}
        <div class="card my-3">
            <img src="{{ photo.photo.url }}" alt="{{ photo.label }}" class="card-img-top">
            <div class="card-body">
                <h3 class="card-title">{{ photo.label }}</h3>
                <p class="card-subtitle text-muted">{{ photo.author }} | {{ photo.created_at|date:"Y-m-d H:i:s" }} |
                    likes: <span id="likes-display-{{ photo.pk }}">{{ photo.likes_count }}</span></p>
                {% if request.user.is_authenticated %}
                    <p class="mt-2 mb-0">
                        <a href="#" class="btn btn-success like-btn" id="like-btn-{{ photo.pk }}"
                           data-id="{{ photo.pk }}">Like</a>
                        <a href="#" class="btn btn-danger dislike-btn" id="dislike-btn-{{ photo.pk }}"
                           data-id="{{ photo.pk }}">Dislike</a>
                    </p>
                {% endif %}
                <p class="mt-2 mb-0">
                    <a href="{% url "webapp:photo_detail" photo.pk %}" class="card-link">Читать дальше</a>
                </p>
            </div>
        </div>
    {% endfor %}
{% endblock %}